// ActionScript file
import flash.events.MouseEvent;

import mx.collections.ArrayCollection;
import mx.controls.Image;
import mx.events.FlexEvent;
import mx.rpc.events.ResultEvent;
import mx.rpc.http.HTTPService;
import mx.utils.ObjectProxy;

import spark.components.BorderContainer;
import spark.components.HGroup;
import spark.components.Label;
import spark.components.VGroup;
import spark.layouts.VerticalLayout;

//指定配置文件的目录
public const xmlUrl:String = "menu.xml";

//存放从配置文件读取的菜单信息
private var menuArray:ArrayCollection;



protected function menuMouseOver(event:MouseEvent):void {
	var container:BorderContainer = event.currentTarget as BorderContainer;
	
	container.setStyle('borderVisible', true); 
	container.setStyle('borderColor','#7bc4d3');									
}


protected function menuMouseOut(event:MouseEvent):void {
	var container:BorderContainer = event.currentTarget as BorderContainer;
	container.setStyle('borderVisible', false); 
}	


protected function ConOver(event:MouseEvent):void {	   
	var container:BorderContainer = event.currentTarget as BorderContainer ;
	container.setStyle("borderVisible", true);	
	container.setStyle("borderColor","#a6d0e7");	
	container.setStyle("backgroundAlpha",1.0);
}


protected function ConOut(event:MouseEvent):void {			
	var container:BorderContainer = event.currentTarget as BorderContainer ;
	container.setStyle("borderVisible", false);
	container.setStyle("backgroundAlpha",0);
}   


protected function clickHandler(event:MouseEvent):void
{		
	//根据事件源的ID名来获取将要进行收缩的菜单栏
	var borderContainer:BorderContainer = event.currentTarget as BorderContainer;
	var bcId:String = borderContainer.id;
	var numStringOfMenu:String = (bcId.substring(bcId.length-1, bcId.length));
	var num:int = numStringOfMenu.charCodeAt(0)-48;	
	
	
	
	//获取将进行收缩的菜单栏(有事件元的ID号映射到将要收缩的菜单栏)
	var numOfMenu:int = 3 * num + 1;
	var bc:BorderContainer = (menu.getElementAt(numOfMenu)) as BorderContainer;
	
	bc.includeInLayout=!bc.includeInLayout;
	bc.visible=!bc.visible
	
}

//初始化页面
protected function creationCompleteHandler(event:FlexEvent):void
{
	var service:HTTPService = new HTTPService();
	service.url = xmlUrl;
	service.addEventListener(ResultEvent.RESULT, resultHandler);
	service.send();
}																	



private function resultHandler(event:ResultEvent):void{				
	
	menuArray = event.result.menus.menu as ArrayCollection;   
	
	//遍历menus来构造菜单
	for(var i:int=0; i<menuArray.length; i++) {
		
		//一级菜单
		var borderContainer1:BorderContainer = createBC(i);				
		//将borderContainer1加到外层menu中
		menu.addElement(borderContainer1);
		
		//读取一级菜单的标题		
		var menu_name:String = menuArray.getItemAt(i).header.name;
		var label1:spark.components.Label = setMenuName(menu_name); 
		
		//将label1加到borderContainer1中
		borderContainer1.addElement(label1);
		
		//添加事件来实现菜单栏收缩与展开
		borderContainer1.addEventListener(MouseEvent.CLICK, clickHandler);
		
		var borderContainer2:BorderContainer = createMenuItems(i);
		//将borderContainer2加到外层menu中
		menu.addElement(borderContainer2);
		
		var label3:spark.components.Label = new spark.components.Label();
		label3.height = 4;			
		menu.addElement(label3);
	}	
}


//创建BorderContainer来存放菜单
private function createBC(num:int):BorderContainer 
{
	var borderContainer1:BorderContainer = new BorderContainer();
	borderContainer1.styleName = "menuTitle";
	borderContainer1.width = 151;
	borderContainer1.height = 23;
	borderContainer1.id = "aaa" + num;		//设置id值
	
	return borderContainer1;
}

//设置菜单栏题目
private function setMenuName(menu_name:String):spark.components.Label 
{
	var label1:spark.components.Label = new spark.components.Label();
	label1.text = menu_name;
	label1.buttonMode = true;
	label1.left = 26;
	label1.top = 5;
	
	return label1;
}

//创建二级菜单
private function createMenuItems(num:int):BorderContainer
{
	//Create a BorderContainer to hold menu items
	var borderContainer2:BorderContainer = createMenuItemBC(num);	
	
	var v_group:VGroup = new VGroup();
	v_group.width = borderContainer2.width;
	v_group.height = borderContainer2.height;
	v_group.gap = 0;
	borderContainer2.addElement(v_group);
	
	
	//添加二级菜单	
	var numOfMenuItems:int = menuArray.getItemAt(num).item.length;
	//创建二级菜单			
	for(var j:int=0; j<numOfMenuItems; j++)
	{
		var h_group2:HGroup = createAMenuItem(num,j);		
		v_group.addElement(h_group2);
	}
	
	return borderContainer2;
}

//创建二级菜单容器
private function createMenuItemBC(num:int):BorderContainer 
{	
	var numOfMenuItems2:int = menuArray.getItemAt(num).item.length;
	var borderContainer2:BorderContainer = new BorderContainer();
	borderContainer2.styleName = "menuText";
	borderContainer2.width = 150;
	borderContainer2.height = numOfMenuItems2*25;
	borderContainer2.id = "bc0";
	borderContainer2.setStyle("borderColor", "#7bc4d3");
	borderContainer2.setStyle("font-size", 13);
	borderContainer2.layout = new VerticalLayout();
	return borderContainer2;
}

//创建二级菜单
private function createAMenuItem(num:int,j:int):HGroup
{
	//控制二级菜单布局
	var h_group2:HGroup = new HGroup();
	h_group2.paddingLeft = 20;
	if(j == 0)
	{
		h_group2.paddingTop = 10;		
	}
	
	//添加子项到h_group2
	var h_group1:HGroup = new HGroup();
	h_group1.width = 150;
	h_group1.height = 22;	
	h_group1.gap = 15;
	h_group2.addElement(h_group1);
	
	
	//添加图片
	var img_source:String = menuArray.getItemAt(num).item[j].img_url;
	var img1:Image = new Image();
	img1.source = img_source ;
	img1.width = 10;
	img1.height = 10;	
	h_group1.addElement(img1);
	
	
	var borderContainer3:BorderContainer = new BorderContainer();
	borderContainer3.width = 100;
	borderContainer3.height = 20;
	borderContainer3.setStyle("borderVisible", false);
	borderContainer3.addEventListener(MouseEvent.MOUSE_OVER, menuMouseOver);
	borderContainer3.addEventListener(MouseEvent.MOUSE_OUT, menuMouseOut);
	h_group1.addElement(borderContainer3);
	
	//创建一个Label作为borderContainer3的子元素
	var label_text:String = menuArray.getItemAt(num).item[j].name;	
	var label2:spark.components.Label = new spark.components.Label();
	label2.text = label_text;
	label2.buttonMode = true;
	//将label2加到borderContainer3中
	borderContainer3.addElement(label2);
	
	return h_group2;
}